﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace feladat
{
    class Program
    {
        static bool Volt(int i, int j, int[] x)
        {
            int k = 1;
            while (k < i && x[k - 1] != j)
            {
                k++;
            }
            return k < i;
        }

        static bool Jó(int[] x)
        {
            return x[0] * 1000 +
                     x[1] * 91 +
                     x[2] * -90 +
                     x[3] * 1 +
                     x[4] * -9000 +
                     x[5] * -900 +
                     x[6] * 10 +
                     x[7] * -1 == 0;
        }

        static void Összes_Sorrend(int i, int N, ref int Db, int[,] Y, int[] x)
        {
            if (i == N + 1 && Jó(x))
            {
                for (int j = 0; j < N; j++)
                {   // Y[Db] = x;
                    Y[Db,j] = x[j];
                }
                Db++;
            }
            else if (i <= N)
            {
                int jj;
                if (i == 1 || i == 5)
                {
                    jj = 1;
                }
                else
                {
                    jj = 0;
                }
                for (int j = jj; j <= 9; j++)
                {
                    if (!Volt(i, j, x))
                    {
                        x[i - 1] = j;
                        Összes_Sorrend(i + 1, N, ref Db, Y, x);
                    }
                }
            }
        }

        static void Megoldás(out int Db, int[,] Y)
        {
            Db = 0;
            const int MaxN = 8;
            int[] x = new int[MaxN];
            Összes_Sorrend(1,8,ref Db,Y,x);
        }

        static void Kiírás(int Db, int[,] Y)
        {
            const string szöveg = "SENDMORY";
            for (int i=0;i<Db;i++)
            {
                for (int j=0;j<8;j++)
                {
                    Console.WriteLine(szöveg[j]+": "+ Y[i,j]+" ");
                }
            }
        }

        static void Main(string[] args)
        {
            //F1. Összes lehetséges sorrend
            //Maximális elemszám
            const int MaxN = 8;
            const int MaxDb = 10000;
            //A mátrix deklarálása
            int[,] Y = new int[MaxDb, MaxN];
            //Kimeneti adatok deklarálása
            int Db;
            //Lényegi megoldás
            Megoldás(out Db,Y);
            //Kiírás
            Kiírás(Db, Y);
        }
    }
}
